• HDU 5375 Gray code (简单dp)


    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5375


    题面:

    Gray code

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
    Total Submission(s): 626    Accepted Submission(s): 369


    Problem Description
    The reflected binary code, also known as Gray code after Frank Gray, is a binary numeral system where two successive values differ in only onebit (binary digit). The reflected binary code was originally designed to prevent spurious output from electromechanical switches. Today, Gray codes are widely used to facilitate error correction in digital communications such as digital terrestrial television and some cable TV systems.



    Now , you are given a binary number of length n including ‘0’ , ’1’ and ‘?’(? means that you can use either 0 or 1 to fill this position) and n integers(a1,a2,….,an) . A certain binary number corresponds to a gray code only. If the ith bit of this gray code is 1,you can get the point ai.
    Can you tell me how many points you can get at most?

    For instance, the binary number “00?

    0” may be “0000” or “0010”,and the corresponding gray code are “0000” or “0011”.You can choose “0000” getting nothing or “0011” getting the point a3 and a4.

     

    Input
    The first line of the input contains the number of test cases T.

    Each test case begins with string with ‘0’,’1’ and ‘?’.

    The next line contains n (1<=n<=200000) integers (n is the length of the string).

    a1 a2 a3 … an (1<=ai<=1000)
     

    Output
    For each test case, output “Case #x: ans”, in which x is the case number counted from one,’ans’ is the points you can get at most
     

    Sample Input
    2 00?

    0 1 2 4 8 ??

    ?? 1 2 4 8

     

    Sample Output
    Case #1: 12 Case #2: 15
    Hint
    https://en.wikipedia.org/wiki/Gray_code http://baike.baidu.com/view/358724.htm
     

    Source



    解题:
        类似2014区域赛的一道简单dp。

    首先要知道格雷码是怎么算的,格雷码就是当前这一位的二进制表示和其前一位的二进制表示同样时,取0否则取1.(觉得最高位前面一位为0)。


        状态转移方程为:
                                 dp[i][0]=max(dp[i-1][0],dp[i-1][1]+a[i]);
                                 dp[i][1]=max(dp[i-1][1],dp[i-1][0]+a[i]);
        但由于某些位是给定的,所以仅仅能算当中部分状态。加一些if推断就可以,详见代码。如有问题。欢迎交流!!



    代码:

    #include<iostream>
    #include<cstdio>
    #include<algorithm>
    #include<cstring>
    #define INF 1000000000
    using namespace std;
    char s[200005];
    int a[200005],dp[200005][2];
    int max(int a,int b)
    {
        return a>b?a:b;
    }
    int main()
    {
        int t,len,i,cnt=1;
        scanf("%d",&t);
        getchar();
        while(t--)
        {
            scanf("%s",s+1);
            len=strlen(s+1);
            for(i=1;i<=len;i++)
            {
                scanf("%d",&a[i]);
                getchar();
            }
            memset(dp,0,sizeof(dp));
            if(s[1]=='0')
                dp[1][0]=0;
            else if(s[1]=='1')
                dp[1][1]=a[1];
            else
            {
                dp[1][1]=a[1];
                dp[1][0]=0;
            }
            for(i=2;i<=len;i++)
            {
                if(s[i]=='0')
                {
                    if(s[i-1]=='0')
                        dp[i][0]=dp[i-1][0];
                    else if(s[i-1]=='1')
                        dp[i][0]=dp[i-1][1]+a[i];
                    else
                        dp[i][0]=max(dp[i-1][0],dp[i-1][1]+a[i]);
                }
                else if(s[i]=='1')
                {
                    if(s[i-1]=='0')
                        dp[i][1]=dp[i-1][0]+a[i];
                    else if(s[i-1]=='1')
                        dp[i][1]=dp[i-1][1];
                    else 
                      dp[i][1]=max(dp[i-1][0]+a[i],dp[i-1][1]);
                }
                else
                {
                    if(s[i-1]=='0')
                    {
                        dp[i][1]=dp[i-1][0]+a[i];
                        dp[i][0]=dp[i-1][0];
                    }
                    else if(s[i-1]=='1')
                    {
                        dp[i][1]=dp[i-1][1];
                        dp[i][0]=dp[i-1][1]+a[i];
                    }
                    else 
                    {
                        dp[i][1]=max(dp[i-1][0]+a[i],dp[i-1][1]);
                        dp[i][0]=max(dp[i-1][0],dp[i-1][1]+a[i]);
                    }
                }
            }
            printf("Case #%d: ",cnt++);
            printf("%d
    ",max(dp[len][0],dp[len][1]));
        }
        return 0;
    }


  • 相关阅读:
    输入年月日,输出这一天是这一年的多少天
    判断体重是否标准 男标准=身高-100±3 女标准=身高-110±3
    if 条件运算符
    24小时换算成12小时&&判断正负数
    运算符(编程)
    定义变量
    基础知识
    java线程阻塞中断与LockSupport使用介绍(转)
    01背包问题--动态规划解法(2)(转载)
    01背包问题--动态规划解法
  • 原文地址:https://www.cnblogs.com/yjbjingcha/p/6953076.html
Copyright © 2020-2023  润新知